require_relative "./lib/nonoengine"
require_relative "./resources"

class MainMenu
  attr_accessor :active

  def initialize
    RES::Gui::Music.music
    @active = true
    @gamestarted = false

    @new_game = RES::Gui::Btn.clone
    @volume = RES::Gui::Btn.clone
    @exit = RES::Gui::Btn.clone

    #RES::Gui::Font.config(color: Engine::Colors.new(0x74, 0x64, 0x51, 255))
    RES::Gui::Font.config(color: Engine::Colors::BLACK)
  end

  def volume_bar(value)
    Engine.layer = 101
    x0 = Engine::GUI[GUI::X]
    y0 = Engine::GUI[GUI::Y]
    w = Engine::GUI[GUI::WIDTH]
    h = Engine::GUI[GUI::HEIGHT]
    sx = 127.0 / w
    sy = 28.0 / h
    w *= value
    RES::Gui::Fill.tex_triangle2(x0, y0, x0 + w, y0, x0 + w, y0 + h, 0, 0, sx, sy)
    RES::Gui::Fill.tex_triangle2(x0, y0, x0, y0 + h, x0 + w, y0 + h, 0, 0, sx, sy)
  end

  def draw
    camera(0, 0)
    Engine.panel(1, 0, 0, 150, 260, 300, Align::CENTER, Align::NONE)
    RES::Gui::Back.show(1, 0, 0, 330, 360, Align::CENTER, Align::CENTER)

    if @new_game.show(1, 10, 10, 250, 40, Align::CENTER, Align::FLOW, @gamestarted ? "Продолжить" : "Новая игра", RES::Gui::Font) == :clicked
      @active = false
      @catching = false
      @gamestarted = true
      #return
    end

    RES::Gui::Empty.show(1, 10, 20, 250, 40, Align::CENTER, Align::FLOW, "Громкость: #{Engine[Params::Volume]}", RES::Gui::Font)
    if RES::Gui::Volume.show(1, 10, 0, 250, 40, Align::CENTER, Align::FLOW) == :pressed
      Engine[Params::Volume] = 100 * Engine::GUI[GUI::MOUSE_X]
    end
    volume_bar(Engine[Params::Volume] / 100.0)

    if @exit.show(1, 10, 20, 250, 40, Align::CENTER, Align::BOTTOM, "Выход", RES::Gui::Font) == :clicked
      $game.should_quit = true
      #return
    end
  end

  def update
    esc_down = Engine::Key[KEY_ESCAPE] != :up
    @catching = true if !esc_down
    if esc_down && @catching && @gamestarted
      @catching = false
      @active = false
    end
  end
end
