class HouseGenerator < MapGenerator
  def self.get_size
    50
  end

  def find_bed
    y = @size - 1
    loop do
      y -= 1
      list = (1..@size - 1).to_a.select do |x|
        tile(x, y) == Bearlib::TILE_BIGROOM
      end
      next if list.size == 0
      @bed = [list.sample, y]
      break
    end
  end

  def find_out
    y = 1
    loop do
      y += 1
      list = (1..@size - 1).to_a.select do |x|
        tile(x, y) == Bearlib::TILE_BIGROOM
      end
      next if list.size == 0
      @out = [list.sample, y]
      break
    end
  end

  def entry
    @bed
  end

  def generate(data)
    bearmap = Bearlib::Map.new(@size, @size, {cells: :integer})
    layer = bearmap.layers[:cells]
    @tile_data = Array.new(@size * @size)
    @wave_data = Array.new(@size * @size)
    loop do
      layer.generate(Bearlib::G_NICE_DUNGEON, SEED)
      (@size * @size).times do |i|
        x = i % @size
        y = i / @size
        @tile_data[y * @size + x] = layer[x, y]
      end
      next unless check_space
      next unless check_connected
      break
    end
    fix_walls
    double_size if @double
    find_bed
    find_out
    make_from_tile_data data

    data[(@out[1] - 1) * @size + @out[0]] = {
      pass: false,
      picture: TILE_HOMEDOOR,
      logic: LogicalTile::Stair,
    }
  end
end
