class PortalTownGenerator < MapGenerator
  def self.get_size
    200
  end

  def shift_terrain(data)
    data.map! do |v|
      {
        pass: v[:pass],
        picture: v[:picture] + 5 * 8,
        logic: v[:logic],
      }
    end
  end

  def add_house(x, y, w, h)
    return if (x - 1..x + w).include?(@portal[0]) && (y - 1..y + h).include?(@portal[1])
    # (x - 1..x + w).each do |ax|
    #   (y - 1..y + h).each do |ay|
    #     t = tile(ax, ay)
    #     return if [Bearlib::TILE_CAVE_WALL, Bearlib::TILE_HOUSE_FLOOR].include? t
    #     #return if t == Bearlib::TILE_ROOMWALL
    #   end
    # end

    @houses << [x, y, w, h]
    (x...x + w).each do |ax|
      (y...y + h).each do |ay|
        @tile_data[ay * @size + ax] = Bearlib::TILE_ROOMWALL
      end
    end
  end

  def entry
    @portal
  end

  def for_door(x, y)
    t = tile(x, y)
    return 0 if t == Bearlib::TILE_ROOMWALL
    return 1 if t == Bearlib::TILE_SMALLROOM
    2
  end

  def generate(data)
    loop do
      @tile_data = Array.new(@size * @size, Bearlib::TILE_SMALLROOM)
      @size.times do |i|
        @tile_data[0 * @size + i] = Bearlib::TILE_ROOMWALL
        @tile_data[(@size - 1) * @size + i] = Bearlib::TILE_ROOMWALL
        @tile_data[i * @size + 0] = Bearlib::TILE_ROOMWALL
        @tile_data[i * @size + (@size - 1)] = Bearlib::TILE_ROOMWALL
      end

      @wave_data = Array.new(@size * @size)

      @houses = []
      #place a portal
      @portal = [@size / 2, @size / 2]
      (-3..3).each do |dx|
        (-3...3).each do |dy|
          @tile_data[(dy + @portal[1]) * @size + (dx + @portal[0])] = Bearlib::TILE_HOUSE_FLOOR
        end
      end

      #place some houses
      (0.012 * 4 * @size * @size).to_i.times do
        w = rand(5) + 2
        h = rand(3) + 2
        x = rand(@size - w)
        y = rand(@size - h)
        add_house x, y, w, h
      end

      #check_connected(@portal)
      #now place doors for connected houses
      40000.times do
        x = rand(@size - 2) + 1
        y = rand(@size - 2) + 1
        next unless for_door(x, y) == 1
        n = for_door(x, y - 1)
        s = for_door(x, y + 1)
        w = for_door(x - 1, y)
        e = for_door(x + 1, y)
        if n == 1 && s == 1 && w == 0 && e == 0
          @tile_data[y * @size + x] = Bearlib::TILE_DOOR
          @tile_data[(y + 1) * @size + x] = Bearlib::TILE_BIGROOM
        end
        if n == 0 && s == 0 && w == 1 && e == 1
          @tile_data[y * @size + x] = Bearlib::TILE_DOOR
          @tile_data[y * @size + x + 1] = Bearlib::TILE_BIGROOM
        end
      end

      break
    end

    #fix_walls
    double_size if @double
    @portal = [@size / 2, @size / 2]
    make_from_tile_data data
    shift_terrain data
  end
end
