require_relative "dance"

BATTLEMAGE_DANCE = {
  desc: "Ближний бой",

  class: DanceSkill,
  delay: 70,
  damage: 3,
  force: 400.0,
}

BATTLEMAGE_SPEAR = {
  desc: "Магическая ракета",
  class: ShootSkill,
  picture: PROJ_LIGHT,
  maxrange: 40,
  speed: 2000,
  spread: 0.1,
  count: 10,
  delay: 105,
  damage: 1,
  force: 5.0,
  pierce: 100,
  sound: RES::Skills::Lightning,
}

class FearPain < Skill
  def update
    if rand < @owner.pain / PLAYER_HP
      @owner.left_skill.delay += @stats[:level]
      @owner.right_skill.delay += @stats[:level]
    end
  end
end

BATTLEMAGE =
  {
    material: MAT_PLAYER,
    picture: 13 * 8 + 5,
    name: "Волшебник",
    desc: "от боли теряет концентрацию",

    left_skill: BATTLEMAGE_SPEAR,
    right_skill: BATTLEMAGE_DANCE,
    passive: {
      class: FearPain,
      level: 0.75,
    },
  }
